{*********************************************************}
{                                                         }
{     TExcel Component Demo 3.0                           }
{                                                         }
{     Copyright (c) 1996, 1998 by                         }
{                                                         }
{       Stefan Hoffmeister                                }
{         Stefan.Hoffmeister@PoBoxes.com                  }
{         Stefan.Hoffmeister@Uni-Passau.de                }
{                                                         }
{   and (portions)                                        }
{                                                         }
{       Tibor F. Liska                                    }
{       Tel/Fax:    00-36-1-165-2019                      }
{       Office:     00-36-1-269-8284                      }
{       E-mail: liska@sztaki.hu                           }
{                                                         }
{                                                         }
{   High-speed code copyright 1997, 1998                  }
{              by Stefan Hoffmeister                      }
{                                                         }
{     http://www.shareit.com/programs/100506.htm          }
{                                                         }
{*********************************************************}

unit DemoXL1;

{ The conditional define below determines whether the
  high-speed code should be activated.

  Usually you will NOT have the high-speed code, as it is
  only available to registered users of this component.

  Please browse to

    http://www.shareit.com/programs/100506.htm

  to learn more about the benefits of registration.

  If you do NOT have the high-speed code yet, please remove
  this conditional define temporarily }


{ **************   REMOVE THIS   ************** }
{$DEFINE UltraSpeed}
{ **************   REMOVE THIS   ************** }


interface

uses
  {$IFDEF Win32}
    ComCtrls,

    {$IFDEF VER90}
      OleAuto,
    {$ELSE}
      ComObj,
    {$ENDIF VER90}

  {$ELSE}
      { ---> deactivate the define if you do not have RX library 2.50,
        an excellent free library (http://rx.demo.ru/) }
    {$DEFINE Have_RX}
    {$IFDEF Have_RX} Ole2, Ole2Auto, Dispatch, RXConst, {$ENDIF Have_RX}
  {$ENDIF Win32}

  WinTypes, WinProcs,

  Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, TabNotBk, DdeMan,

  Excels;

type
  TForm1 = class(TForm)
    cmClose: TBitBtn;
    Timer1: TTimer;
    TabbedNotebook1: TTabbedNotebook;
    cmTable: TBitBtn;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Edit1: TEdit;
    cmRequest: TBitBtn;
    cmRun: TBitBtn;
    ComboBox3: TComboBox;
    Label4: TLabel;
    cmCommand: TBitBtn;
    ComboBox1: TComboBox;
    Label6: TLabel;
    RequestMemo: TMemo;
    ComboBox4: TComboBox;
    Label7: TLabel;
    SpecialRequestEdit: TEdit;
    cmRequestSelection: TBitBtn;
    SelectionLabel: TLabel;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    cmPutData: TBitBtn;
    RadioGroup1: TRadioGroup;
    Edit2: TEdit;
    cmRequestData: TBitBtn;
    reqDataLabel: TLabel;
    Label8: TLabel;
    cmListSelection: TBitBtn;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    cmHighSet: TButton;
    cmHighGet: TButton;
    GroupBox1: TGroupBox;
    Label5: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    AdvExcel1: TAdvExcel;
    Label16: TLabel;
    lblWriteCache: TLabel;
    btCompare: TButton;
    Label18: TLabel;
    Label19: TLabel;
    Label17: TLabel;
    cbWriteCacheComp: TComboBox;
    lblResultNoCache: TLabel;
    lblResultWithCache: TLabel;
    Label20: TLabel;
    Label21: TLabel;
    Label22: TLabel;
    Label23: TLabel;
    Button1: TButton;
    Label24: TLabel;
    Label25: TLabel;
    SpinEdit1: TEdit;
    SpinEdit2: TEdit;
    SpinEdit5: TEdit;
    SpinEdit4: TEdit;
    SpinEdit3: TEdit;
    Label26: TLabel;
    eHSRow: TEdit;
    eHSCol: TEdit;
    eHSRowCount: TEdit;
    eHSColCount: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Timer1Timer(Sender: TObject);
    procedure ExcelOpen(Sender: TObject);
    procedure ExcelClose(Sender: TObject);
    procedure cmCloseClick(Sender: TObject);
    procedure cmTableClick(Sender: TObject);
    procedure cmCommandClick(Sender: TObject);
    procedure cmRequestClick(Sender: TObject);
    procedure cmRunClick(Sender: TObject);
    procedure cmRequestSelectionClick(Sender: TObject);
    procedure ComboBox4Change(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure cmPutDataClick(Sender: TObject);
    procedure cmRequestDataClick(Sender: TObject);
    procedure cmListSelectionClick(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure cmHighSetClick(Sender: TObject);
    procedure cmHighGetClick(Sender: TObject);
    procedure btCompareClick(Sender: TObject);
    procedure TabbedNotebook1Change(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure NumericKeyPress(Sender: TObject; var Key: Char);
  private
    MacroFile: TFileName;
    Excel: TAdvExcel;

    procedure SetGuiEnabled(Enable: boolean);
  public
    procedure TestExcelInstance;
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

uses
  DemoXL2; { a form used to display rectangular
             selections retrieved from Excel }

procedure TForm1.FormCreate(Sender: TObject);
begin
  { make sure that we have a component available }
  Excel := FindComponent('AdvExcel1') as TAdvExcel;
  if Excel = nil then
    Excel := TAdvExcel.Create(Self);

  { prepare form }
  TabbedNotebook1.ActivePage := 'Create+Store';
  { TabbedNotebook1.ActivePage := 'Write cache'; }

  ComboBox1.ItemIndex := -1;
  ComboBox3.ItemIndex := -1;
  ComboBox4.ItemIndex := -1;

  RadioGroup1.ItemIndex := ord(Excel.MoveActiveCell);

  cbWriteCacheComp.ItemIndex := 0;

  MacroFile := ExtractFilePath(ParamStr(0))+'DemoXL.xls';
  if not FileExists(Macrofile) then
    MacroFile := '';

  Timer1.Enabled := true; { Delayed connect to Excel }
  Screen.Cursor := crHourGlass;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Excel.CloseMacroFile;

  Excel.CloseExcel;

  { don't want to have any notifications any longer }
  Excel.OnClose := nil;
  Excel.Disconnect;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  ExcelPath : string;
begin
  Timer1.Enabled := false;
  try
    Excel.OnOpen  := ExcelOpen;
    Excel.OnClose := ExcelClose;

    try
      Excel.Connect;   { Same as Excel.Connected := true; }
    except
      ExcelPath := '';
      if InputQuery( 'Excel could not be found',
                     'Specify Excel path',
                     ExcelPath ) then
      begin
        Excel.ExeName := ExcelPath;
        Excel.Connect;
      end
      else
        raise;
    end;

  finally
    Screen.Cursor := crDefault;
  end;
end;

procedure TForm1.SetGuiEnabled(Enable: boolean);
begin
  cmTable  .Enabled := Enable;
  cmCommand.Enabled := Enable;
  cmRequest.Enabled := Enable;
  cmRequestSelection.Enabled := Enable;
  cmListSelection.Enabled := Enable;
  cmRequestData.Enabled := Enable;
  cmPutData.Enabled := Enable;

  cmHighSet.Enabled := Enable;
  cmHighGet.Enabled := Enable;

  btCompare.Enabled := Enable;
end;

procedure TForm1.ExcelOpen(Sender: TObject);
begin
  { ShowMessage('Excel connection opened'); }
  SetGuiEnabled(true);

  cmRun.Enabled := MacroFile <> '';
  Excel.IgnoreErrors := true;
end;

procedure TForm1.ExcelClose(Sender: TObject);
begin
  { ShowMessage('Excel connection closed'); }

  SetGuiEnabled(false);

  cmRun.Enabled := false;
end;

procedure TForm1.cmCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TForm1.NumericKeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in ['0'..'9', #8]) then
  begin
    Key := #0;
    MessageBeep(MB_ICONASTERISK);
  end;
end;

procedure TForm1.cmTableClick(Sender: TObject);
begin
  Excel.NewWorkbook(Sheet, '');
  { Excel.StartTable; <-- do not use any longer } { Create new workbook }

  { standard behaviour without caching }
  Excel.PutStrAt( StrToInt(SpinEdit1.Text), StrToInt(SpinEdit2.Text),
                  Edit1.Text);

  Excel.PutIntAt( StrToInt(SpinEdit3.Text), StrToInt(SpinEdit4.Text),
                  StrToInt(SpinEdit5.Text));

  { Excel.EndTable; <-- do not use any longer } { Show excel table }
end;

procedure TForm1.cmCommandClick(Sender: TObject);
begin
  Excel.Exec(ComboBox1.Text);
end;

procedure TForm1.cmRequestClick(Sender: TObject);
begin
  RequestMemo.Clear;
  RequestMemo.Lines.Add(Excel.Request(SpecialRequestEdit.Text));
end;

procedure TForm1.cmRunClick(Sender: TObject);
begin
  Excel.OpenMacroFile(MacroFile);
  Excel.RunMacro(ComboBox3.Text);
end;

procedure TForm1.cmRequestSelectionClick(Sender: TObject);
begin
  SelectionLabel.Caption := Excel.Selection;
end;

procedure TForm1.ComboBox4Change(Sender: TObject);
var
  Result : TStringList;
begin
  RequestMemo.Clear;

  case ComboBox4.ItemIndex of
    0 : Result := Excel.Topics;
    1 : Result := Excel.Protocols;
    2 : Result := Excel.Formats;
    3 : Result := Excel.EditEnvItems;
  else
    Result := nil;
  end;

  if Result <> nil then
    RequestMemo.Lines.Assign(Result);
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  with Excel do
    if CheckBox1.Checked then
      EchoOn
    else
      EchoOff;
end;

procedure TForm1.CheckBox2Click(Sender: TObject);
begin
  with Excel do
    if CheckBox2.Checked then
      EnableInput
    else
      DisableInput;
end;

procedure TForm1.CheckBox3Click(Sender: TObject);
begin
  Excel.FilterReturnedData := CheckBox3.Checked;
end;

procedure TForm1.CheckBox4Click(Sender: TObject);
begin
  Excel.StripCRLF := CheckBox4.Checked;
end;


procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  Excel.MoveActiveCell := TCellDir(RadioGroup1.ItemIndex);
end;

procedure TForm1.cmPutDataClick(Sender: TObject);
begin
  Excel.PutData( [Edit2.Text] );
(*
  { Extended examples of usage: }
  { Note: this writes data to A1 with the cell marker going right }
  Excel.PutDataAt(1, 1, [1, 2.2, 'Hello!', '', 1], dirRight);
*)
end;

procedure TForm1.cmRequestDataClick(Sender: TObject);
var
  TopLeft: TExcelCell;
  BottomRight: TExcelCell;

  i, j: integer;

  ASheet: string;
begin
  reqDataLabel.Caption := Excel.GetData;
  { retrieve single cell at selection }

(*
  { Extended example of usage -
        gets data in call Row 10, Column 20 in the CURRENT sheet }

  reqDataLabel.Caption := Excel.GetDataAt(10, 20);
*)


  { now fill a complete string grid with data }
  with TArrayForm.Create(Self) do
  try

    ASheet := Excel.GetRectSelection(TopLeft, BottomRight);
    Label2.Caption := ASheet;

    if (TopLeft.Col <> BottomRight.Col) or
       (TopLeft.Row <> BottomRight.Row) then
    begin
      { we do have an array selection }

      { adapt grid to selection }
      StringGrid1.ColCount := BottomRight.Col - TopLeft.Col + 1;
      StringGrid1.RowCount := BottomRight.Row - TopLeft.Row + 1;

      { fill grid }
      for i := TopLeft.Col to BottomRight.Col do
        for j := TopLeft.Row to BottomRight.Row do
          StringGrid1.Cells[i-TopLeft.Col, j-TopLeft.Row] :=
            { speed matters up - we tell the component which File+Sheet we want }
            Excel.GetDataAtFileSheet(j, i, ASheet);

      { show form }
      ShowModal;
    end;

  finally
    Release;
  end;
end;

procedure TForm1.cmListSelectionClick(Sender: TObject);
var
  counter: integer;
begin
  Excel.RetrieveSelection;

  RequestMemo.Clear;

  RequestMemo.Lines.Add('Parsed selection:');
  for counter := 0 to Excel.SelectionList.Count-1 do
    with PExcelSelectionArray(Excel.SelectionList.Objects[counter])^ do

      RequestMemo.Lines.Add(  Format('%s: %s%d%s%d:%s%d%s%d',
                              [ Excel.SelectionList[counter],

                                Excel.ColChar, TopLeft.Col,
                                Excel.RowChar, TopLeft.Row,

                                Excel.ColChar, BottomRight.Col,
                                Excel.RowChar, BottomRight.Row
                                 ]) );
end;


const
  STrialMessage = 'Please contact Stefan Hoffmeister for the high-'#13 +
                  'speed DDE code; up to 65000 elements in 120 ms!'#13#13+
                  'A trial component can be found in the TRIAL subfolder'#13#13+
                  'eMail: Stefan.Hoffmeister@PoBoxes.com'#13#13+
                  'Home: http://www.poboxes.com/econos/'#13+
                  'Registration: http://www.shareit.com/programs/100506.htm';


procedure TForm1.cmHighSetClick(Sender: TObject);
{$IFNDEF UltraSpeed}
begin
  MessageDlg( STrialMessage, mtInformation, [mbOK], 0);
end;
{$ELSE}
var
  i, counter: integer;

  xl : TSetXlTableData;
(*  if the compiler complains here,
    remove the line
         {$DEFINE UltraSpeed}
    at the top of this unit or contact

      Stefan.Hoffmeister@PoBoxes.com

    on how to licence the high-speed code.

    A trial component can be found in the TIRAL subfolder.

    Online registration is available through

        http://www.shareit.com/programs/100506.htm
*)

var
  HSRow, HSRowCount: TExcelRow;
  HSCol, HSColCount: TExcelCol;

  t: longint;
begin
  t := GetTickCount;

  HSRow := StrToInt(eHSRow.Text);
  HSRowCount := StrToInt(eHSRowCount.Text);

  HSCol := StrToInt(eHSCol.Text);
  HSColCount := StrToInt(eHSColCount.Text);

  Excel.Select(HSRow, HSCol);

  counter := HSRowCount * HSColCount;

  { create a custom table }
  xl := TSetXlTableData.Create(HSRowCount, HSColCount);
  try

    for i := 1 to counter do
    begin
      case Random(5) of
        0: xl.AddFloat(Random);
        1: xl.AddString('Random string');
        2: xl.AddBool(true);
        3: xl.AddBlank;
        4: xl.AddInt(Random(10000));
      end;
    end;

    { ...and write the data into Excel }
    with Excel do
      SetXlTable(xl);

  finally
    xl.Free;
  end;

  MessageDlg( Format( 'Operation took %d ms INCLUDING creation of data.'#13#13+
                      'Speed can possibly be improved if Excel is visible or'#13+
                      'not minimized.',

                      [GetTickCount - t]),
              mtInformation, [mbOK], 0);
end;
{$ENDIF}

procedure TForm1.cmHighGetClick(Sender: TObject);
{$IFNDEF UltraSpeed}
begin
  MessageDlg( STrialMessage, mtInformation, [mbOK], 0);
end;
{$ELSE}
var
  xl : TGetXlTableData;
(*  if the compiler complains here,
    remove the line
         {$DEFINE UltraSpeed}
    at the top of this unit or contact

      Stefan.Hoffmeister@PoBoxes.com

    on how to licence the high-speed code.

    A trial component can be found in the demo subfolder.

    Online registration is available through

        http://www.shareit.com/programs/100506.htm
*)

  i, j : integer;

  t: longint;

var
  HSRow, HSRowCount: TExcelRow;
  HSCol, HSColCount: TExcelCol;

const
  BoolString : array[boolean] of string[5] = ('false', 'true');
begin
  t := GetTickCount;

  HSRow := StrToInt(eHSRow.Text);
  HSRowCount := StrToInt(eHSRowCount.Text);

  HSCol := StrToInt(eHSCol.Text);
  HSColCount := StrToInt(eHSColCount.Text);

  { Get a eHSRowCount * eHSColCount sized selection at eHSRow, eHSCol }
  xl := Excel.GetXlTableAt( HSRow, HSCol,
                            HSRowCount, HSColCount);

  try
    with TArrayForm.Create(Self) do
    try
      { show the sheet's name }
      Label2.Caption := Excel.CurrentSheet;

      { adapt grid to selection }
      StringGrid1.ColCount := HSColCount;
      StringGrid1.RowCount := HSRowCount;

      { fill grid }

      { Excel may return less data than requested, for instance if the
        whole table returned is empty (all cells are xlDataBlank)
        or the amount data does exceed the limits imposed by the format }
      for j := 0 to xl.RowCount-1 do
        for i := 0 to xl.ColCount-1 do

          with StringGrid1 do
          { read through the stream of data and take appropriate action }
          case xl.NextType of
            xlDataBlank : begin
                            Cells[i, j] := '';
                            xl.Skip;
                          end;

            xlDataFloat : Cells[i, j] := FloatToStr(xl.GetFloat);

            xlDataString: Cells[i, j] := xl.GetString;

            xlDataBool  : Cells[i, j] := BoolString[xl.GetBool];

            xlDataError : begin
                            { Z:= } xl.GetError;
                            { do not bother to write out the "correct"
                              text for the error }
                            Cells[i, j] := '#ERR';
                          end;

            xlDataInt   : Cells[i, j] := IntToStr(xl.GetInt);

            xlDataNone  : begin
                            MessageDlg( 'Selection returned incomplete - too large',
                                        mtError, [mbOK], 0);
                            break;
                          end; { no more data }
          else
            Cells[i, j] := 'Cannot handle'; { should not happen }
            xl.Skip;
          end; { case }

      MessageDlg( Format( 'Operation took %d ms INCLUDING expensive parsing.'#13#13+
                          'Speed can possibly be improved if Excel is VISIBLE or'#13+
                          'NOT MINIMIZED.', [GetTickCount - t]),
                  mtInformation, [mbOK], 0);
      { show form }

      MessageDlg( Format('Excel returned a %dx%d sized table.', [xl.RowCount, xl.ColCount]),
                  mtInformation, [mbOK], 0 );

     { always test how much data Excel returned! }
      if (xl.RowCount <> HSRowCount) or (xl.ColCount <> HSColCount) then
        MessageDlg( 'Excel returned a different amount of data than you asked for.'#13 +
                    'Perhaps you asked for too much data.'#13#13+
                    'Alternatively, some of the requested cells may be empty.',
                    mtWarning, [mbOK], 0);

      ShowModal;
    finally
      Release;
    end;

  finally
    xl.Free;
  end;
end;
{$ENDIF}

procedure TForm1.btCompareClick(Sender: TObject);
var
  RowCount,
  ColCount: integer;


    procedure PushData;
    var
      i, j: integer;
    begin
      for i := 1 to RowCount do
      begin
        for j := 1 to ColCount do
          Excel.PutIntAt(i, j, longint(j)*longint(i)); { typecast to longint for Delphi 1 - 16bit multiply }

        { show progress... just to update the label we need Application.ProcessMessages }
        { note: this slows down the *measured* throughput; real throughput is higher }
        lblWriteCache.Caption := IntToStr( longint(i) * longint(ColCount));
        Application.ProcessMessages;

      end;
    end;

var
  t: longint;
begin
  lblResultNoCache.Caption := '';
  lblResultWithCache.Caption := '';

  with cbWriteCacheComp do

    if Text = '100 x 25' then
    begin
      RowCount := 100; ColCount := 25;
    end
    else
    if Text = '200 x 50' then
    begin
      RowCount := 200; ColCount := 50;
    end
    else
    if Text = '1000 x 255' then
    begin
      RowCount := 1000; ColCount := 255;
    end
    else
      raise Exception.Create('You need to select an array size to be pushed.');


  Excel.NewWorkbook(Sheet, ''); { Create new workbook in Excel }
  Excel.Select(1, 1); { go to R1C1 / A1 }


  btCompare.Enabled := false;
  Application.ProcessMessages;

  Self.Enabled := false;
  try
    Excel.WaitUntilReady;
    { ************************************************** }
    t := GetTickCount;
    { use no cache to push data }
    PushData;

    lblResultNoCache.Caption := Format('%d ms', [GetTickCount - t]);
    Application.ProcessMessages;

    MessageDlg('Done.', mtInformation, [mbOK], 0);

    { clear content of sheet }
    Excel.SelectRange(1, 1, RowCount, ColCount);
    Excel.Exec('[CLEAR()]');

    MessageDlg('Content of sheet has been cleared.', mtInformation, [mbOK], 0);

    Application.ProcessMessages;
    Excel.WaitUntilReady;
    { ************************************************** }
    t := GetTickCount;

    { use write cache to push data}
    Excel.BeginUpdate;
    try
      PushData;
    finally
      Excel.EndUpdate;
    end;

    lblResultWithCache.Caption := Format('%d ms', [GetTickCount - t]);
    Application.ProcessMessages;

  finally
    btCompare.Enabled := true;
    Self.Enabled := true;
  end;
end;

procedure TForm1.TabbedNotebook1Change(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
  AllowChange := true;

  if NewTab = 4 then { write-cache tab? }
  begin
    if not Excel.WriteCacheAvailable then
      MessageDlg( 'The write cache code is not present.'#13#13+
                  'Please use the registered version of the component '+
                  'or try the compiled DCU in the TRIAL directory',
                  mtInformation, [mbOK], 0);
  end;
end;


procedure TForm1.TestExcelInstance;
begin
  if not Excel.OneExcelInstance then
  begin
    MessageDlg( 'One instance ONLY of Excel must be running when mixing DDE and OLE.',
                mtError, [mbOK], 0);
    Abort;
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
{$IFDEF Windows}
var
  ActiveSheet: PVariant;
{$ELSE}
var
  ExcelInstance: Variant;

  aLCID: LCID;

     function MakeLCID(LanguageID, SortID: word): DWORD;
     begin
       Result := (SortID shl 16) or LanguageID;
     end;

     function MakeLangID(PrimaryLanguage, SubLanguage: word): word;
     begin
       Result := (SubLanguage shl 10) or PrimaryLanguage;
     end;

{$ENDIF Windows}
begin
{$IFDEF Windows}

  {$IFNDEF Have_RX}

  raise Exception.Create( 'Delphi 1 does not have built-in OLE automation support, but the free '+
                          'RX Library available from http://rx.demo.ru provides an excellent '+
                          'object adding this feature.'


  {$ELSE}

  { the following code can be used with Delphi 1 and the RX library, version 2.40 }

  Self.TestExcelInstance; { test whether there is one instance only of Excel }

  { *************************************************************** }
  Excel.PutIntAt(1, 1, 1234567); { this is a DDE command }

  with TOleController.Create do
  try
    Locale := MakeLCID( MakeLangID(LANG_ENGLISH, SUBLANG_DEFAULT) );
    GetActiveObject('Excel.Application');

    SetProperty('Visible', [true]);
    ActiveSheet := GetProperty('ActiveSheet');
    with TOleController.Create do
    try
      AssignIDispatch(ActiveSheet^);
      CallFunction('PrintPreview', [true]); { interesting difference between D1, D3 }
    finally
      Free;
    end;

    Application.BringToFront;

  finally
    Free;
  end; { try .. finally }


  {$ENDIF Have_RX}

{$ELSE}

  {$IFDEF VER90}
  MessageDlg( 'Delphi 2 has a problem in the GetIDsOfNames procedure. Because of this OLE, automation calls '+
              'using late binding may fail if your (system''s) language is not English.'#13+
              #13+
              'Delphi 3.02 does not show this problem.',
              mtInformation, [mbOK], 0);
  {$ENDIF VER90}


  // Self.TestExcelInstance; { test whether there is one instance only of Excel }

  { *************************************************************** }
  // Excel.PutIntAt(1, 1, 1234567); { this is a DDE command }


  { *************************************************************** }
  { and here we use the same instance of Excel for OLE automation }

  { *first* make sure that we use a language in OLE automation that Excel will understand
     --> Excel always knows English, so we switch our thread locale to US English.
         We would have a **source** code compatibility problems with late binding if we
         hit upon a German Excel running on a German language system...}

  { WARNING: thread locales are only supported by Windows NT ! }
  aLCID := GetThreadLocale;
  Win32Check( SetThreadLocale(MakeLCID(MakeLangID(LANG_ENGLISH, SUBLANG_DEFAULT), SORT_DEFAULT)) );
  try


    MessageDlg(

           { WARNING: }
           'This OLE operation will probably fail if you are '+
           'not following the instructions discussed in the '+
           'online help section "Combining OLE automation and DDE"',

           mtWarning, [mbOK], 0 );

    ExcelInstance := GetActiveOleObject('Excel.Application');

    ExcelInstance.Visible := true; { this will make Excel visible and bring to the front }
    ExcelInstance.ActiveSheet.PrintPreview;

    Application.BringToFront;

    ExcelInstance := Unassigned; { clean up - but Variant goes out of scope anyway }

  finally
    SetThreadLocale(aLCID); { in order to have no side-effects, see Win32 API help }
  end;
{$ENDIF Windows}
end;

end.

